using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Slb.Horizon.NewUIFramework;

namespace Slb.Horizon.UI.Products.Controls
{
	/// <summary>
	/// Summary description for DataBasedAlarmsUIMgr.
	/// </summary>
	public class AlarmsManagerUIMgr : UIImpl
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		MenuItem[] m_MyMenuItem;
		//public UIFwkEventHandler DBAlarmsUIClosed = new UIFwkEventHandler();

		public AlarmsManagerUIMgr()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}


		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}


		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// DataBasedAlarmsUIMgr
			// 
			this.Name = "DataBasedAlarmsUIMgr";
		}
		#endregion

		protected override void OnInitialize()
		{			
			try
			{				
				// Adding this UI to the Setup Console MenuItem;
				m_MyMenuItem = new MenuItem[1];
				m_MyMenuItem[0] = new MenuItem("Launch" );
				m_MyMenuItem[0].Click += new System.EventHandler(OnClick);
				base.AddMenuToConsole(m_MyMenuItem);
			}
			catch (Exception exp)
			{
				MessageBox.Show(exp.Message,"Initialization Error: " + exp.Message,
					MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}	
	

		/// <summary>
		/// Create form which will contain USE UI.
		/// Set newly created form as parent of USE UI.
		/// Display this form as Modal dialog.
		/// </summary>
		private void OnClick(object sender, System.EventArgs e)
		{
			string AlarmUIXml;
			System.IO.StreamReader sr = null;
			Microsoft.Win32.RegistryKey k;

			try
			{
			
				// Get the Install Directory
				k = Microsoft.Win32.Registry.LocalMachine.OpenSubKey(@"SOFTWARE\Schlumberger\Console\");
			
				// File Name
				string FileName = (string) k.GetValue("ProductsInstallDir") +  @"Templates\"
					+ @"AlarmUIDef.xml";


				sr = new System.IO.StreamReader(FileName);
				AlarmUIXml = sr.ReadToEnd();
				sr.Close();
			
				//string AlarmUIXml = "<UserControlLayout><PreferredPaneName>Central Pane</PreferredPaneName><IsMDI>False</IsMDI><GroupControl><Name>Alarm Manager</Name><Qualifier>AlarmUI</Qualifier><TitlebarExists>True</TitlebarExists><State/><UserControlCollection><UserControl><Name>Alarm Manager</Name><Qualifier>Slb.Horizon.UI.Products.Controls.frmDatabasedAlarmUI</Qualifier><FilePath>DatabasedAlarmUI.dll</FilePath><TypeName>Slb.Horizon.UI.Products.Controls.frmDatabasedAlarmUI</TypeName><Size><Width>500</Width><Height>300</Height></Size><MinimumSize><Width>100</Width><Height>100</Height></MinimumSize></UserControl></UserControlCollection></GroupControl></UserControlLayout>";
				ISlbUI objAlarmUI = (ISlbUI)base.AddUI(AlarmUIXml, null);

				if(objAlarmUI != null)
				{
					// Gray out the menu
					m_MyMenuItem[0].Enabled = false;
				}

				//			base.SubscribeToUIFwkEvent(UIFwkEventType.UIFWK_UCCLOSED,
				//						"Slb.Horizon.UI.Products.Controls.frmDatabasedAlarmUI",
				//						AlarmsUIClosed);
				// 2) When the added UI is closed, then enable the menu again.
				// 3) Maybe need to get an event from the UI
			}
			catch (Exception exp)
			{
				MessageBox.Show(exp.Message,"Alarm Manager UI Loading: " + exp.Message,
					MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}
	}
}
